#include "Stage.h"
#include "Stages.h"
#include "Main.h"
#include "Status.h"
#include "Vram.h"
#include "Sprite.h"
#include "Chars.h"
#include "Man.h"
#include "Box.h"
#include "Rock.h"
#include "Chaser.h"
#include "Ghost.h"
#include "Direction.h"
#include "Point.h"
#include "VVram.h"

const byte[] WallBits = {
    Wall_Right, Wall_Left, Wall_Bottom, Wall_Top
};

ptr<byte> pStage;

byte CurrentTerrain(byte x, byte y)
{
    if (x < MapWidth && y < MapHeight) {
        return *CellMapPtr(x, y);
    }
    return Terrain_Wall;
}


void InitStage() 
{
    ptr< ptr<byte> > pp;
    byte i, j;
    i = 0;
    j = 0;
    pp = Stages;
    while (i < CurrentStage) {
        ++pp;
        ++i;
        ++j;
        if (j >= StageCount) {
            pp = Stages;
            j = 0;
        }
    }
    pStage = *pp;
}


void InitTrying()
{
    ptr<byte> p;

    p = pStage;
    StageTime = 100;
    ClearScreen();
    HideAllSprites();
    PrintStatus();
    // ClearVVram();
    {
        ptr<byte> pCell;
        pCell = CellMap;
        repeat (MapWidth) {
            *pCell = Terrain_Space;
            ++pCell;
        }
        repeat (MapHeight - 1) {
            repeat (MapWidth / 4) {
                byte b;
                b = *p;
                ++p;
                repeat (4) {
                    *pCell = b & 3;
                    ++pCell;
                    b >>= 2;
                }
            }
        }
    }
    p = InitBoxes(p);
    p = InitRocks(p);
    p = InitChasers(p);
    p = InitGhosts(p);
    {
        byte y;
        ptr<byte> pCell;
        pCell = CellMap + MapWidth;
        y = 1;
        repeat (MapHeight - 1) {
            byte x;
            x = 0;
            repeat (MapWidth) {
                byte terrain;
                terrain = *pCell;
                if (terrain == Terrain_Space) {
                    if (y > 1 && (pCell[-MapWidth] & Terrain_Mask) != Terrain_Space) {
                        terrain |= Wall_Top;
                    }
                    if (
                        y >= MapHeight - 1 || 
                        (pCell[MapWidth] & Terrain_Mask) != Terrain_Space
                    ) {
                        terrain |= Wall_Bottom;
                    }
                    if (
                        x < 1 || 
                        (pCell[-1] & Terrain_Mask) != Terrain_Space
                    ) {
                        terrain |= Wall_Left;
                    }
                    if (
                        x > MapWidth - 1 || 
                        (pCell[1] & Terrain_Mask) != Terrain_Space
                    ) {
                        terrain |= Wall_Right;
                    }
                }
                else {
                    terrain |= Wall_All;
                }
                *pCell = terrain;
                // DrawTerrain(x, y, terrain);
                ++pCell;
                ++x;
            }
            ++y;
        }
    }
    // DrawBoxes();
    DrawRocks();
    InitPoints();
    StartChasers();
    StartGhosts();
    StartMan();
    // UpdateSprites();
    DrawAll();
}
