include "VVram.inc"
include "Chars.inc"

ext CellMap_, VVram_

MapWidth equ 16
MapHeight equ 11

; word ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push de
        ex de,hl
            ld h,0
            add hl,hl ;*2
            add hl,hl ;*4
            add hl,hl ;*8
            add hl,hl ;*16
            add hl,hl ;*32
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
        ld de,VVram_
        add hl,de
    pop de
ret


; ptr<byte> CellMapPtr(byte x, byte y);
cseg
CellMapPtr_: public CellMapPtr_
    push af | push de
        ex de,hl
            ld h,0
            add hl,hl ;*2
            add hl,hl ;*4
            add hl,hl ;*8
            add hl,hl ;*16
            ld de,CellMap_
            add hl,de
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
    pop de | pop af
ret

cseg
wallCodes:
    defb Char_Space, Char_Space, Char_Space, Char_Space 
    defb Char_Wall_Left, Char_Space, Char_Wall_Left, Char_Space 
    defb Char_Space, Char_Wall_Right, Char_Space, Char_Wall_Right
    defb Char_Wall_Left, Char_Wall_Right, Char_Wall_Left, Char_Wall_Right
    defb Char_Wall_Top, Char_Wall_Top, Char_Space, Char_Space
    defb Char_Wall_LeftTop, Char_Wall_Top, Char_Wall_Left, Char_Space
    defb Char_Wall_Top, Char_Wall_RightTop, Char_Space, Char_Wall_Right
    defb Char_Wall_LeftTop, Char_Wall_RightTop, Char_Wall_Left, Char_Wall_Right
    defb Char_Space, Char_Space, Char_Wall_Bottom, Char_Wall_Bottom
    defb Char_Wall_Left, Char_Space, Char_Wall_LeftBottom, Char_Wall_Bottom
    defb Char_Space, Char_Wall_Right, Char_Wall_Bottom, Char_Wall_RightBottom
    defb Char_Wall_Left, Char_Wall_Right, Char_Wall_LeftBottom, Char_Wall_RightBottom
    defb Char_Wall_Top, Char_Wall_Top, Char_Wall_Bottom, Char_Wall_Bottom
    defb Char_Wall_LeftTop, Char_Wall_Top, Char_Wall_LeftBottom, Char_Wall_Bottom
    defb Char_Wall_Top, Char_Wall_RightTop, Char_Wall_Bottom, Char_Wall_RightBottom
    defb Char_Wall_LeftTop, Char_Wall_RightTop, Char_Wall_LeftBottom, Char_Wall_RightBottom

; void CellMapToVVram();
cseg
CellMapToVVram_: public CellMapToVVram_
    push af | push hl | push de | push bc
        ld ix,VVram_
        ld hl,CellMap_
        ld c,MapHeight ; vertical count    
        do
            ld b,MapWidth
            do 
                ld e,(hl) | inc hl
                ld a,e
                and 0fh
                if z
                    push hl
                        ld a,e
                        and 0f0h
                        srl a
                        srl a
                        ld e,a
                        ld d,0
                        ld hl,wallCodes
                        add hl,de
                        ld a,(hl) | inc hl 
                        ld (ix),a
                        ld a,(hl) | inc hl 
                        ld (ix+1),a
                        ld a,(hl) | inc hl 
                        ld (ix+VVramWidth),a
                        ld a,(hl)
                        ld (ix+VVramWidth+1),a
                    pop hl
                    jr CellMapToVVramRow_next
                endif
                bit 2,e
                if nz
                    ld (ix),Char_Rock
                    ld (ix+1),Char_Rock+1
                    ld (ix+VVramWidth),Char_Rock+2
                    ld (ix+VVramWidth+1),Char_Rock+3
                    jr CellMapToVVramRow_next
                endif
                cp 1
                if z
                    ld (ix),Char_Soil
                    ld (ix+1),Char_Soil*1
                    ld (ix+VVramWidth),Char_Soil+1
                    ld (ix+VVramWidth+1),Char_Soil
                    jr CellMapToVVramRow_next
                endif
                cp 2
                if z
                    ld (ix),Char_Bedrock
                    ld (ix+1),Char_Bedrock
                    ld (ix+VVramWidth),Char_Bedrock
                    ld (ix+VVramWidth+1),Char_Bedrock
                    jr CellMapToVVramRow_next
                endif
                CellMapToVVramRow_next:
                inc ix | inc ix
            dwnz
            ld de,VVramWidth
            add ix,de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void Put4C(byte x, byte y, byte c);
cseg
Put4C_: public Put4C_
    push af | push hl | push de | push bc
        call VVramPtr_
        ld a,c
        ld c,2
        ld de,VVramWidth-2
        do
            ld b,2
            do
                ld (hl),a
                inc hl
                inc a
            dwnz
            add hl,de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
